var authentication;
var mainUrl;

function login() 
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  } 
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }
  
  xmlhttp.onreadystatechange = function() 
  {
    if (this.readyState == 4 && this.status == 200) 
    {
      var loginResponse = JSON.parse(this.responseText);
      authentication = loginResponse.authentication;
      requestWebSocket(loginResponse);
    }
  };

  setMainUrl();
  var url = mainUrl + "/me/login";

  var username = document.getElementById("username").value;
  var password = document.getElementById("password").value;
  var database = document.getElementById("database").value;
  var credentials = new Object();
  credentials.userName = username;
  credentials.password = password;
  credentials.userSpace = "websocket"; 
  credentials.database = database;

  xmlhttp.open("POST", url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.send(JSON.stringify(credentials));
}



function requestWebSocket()
{
  var xmlhttp;
  if (window.XMLHttpRequest) 
  {
    xmlhttp = new XMLHttpRequest();
  } 
  else 
  {
    // code for older browsers
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }
  
  xmlhttp.onreadystatechange = function() 
  {
    if (this.readyState == 4 && this.status == 200) 
    {
      var response = JSON.parse(this.responseText);
      initWebSocket(response.object);
    }
  };

  var url = mainUrl + "/me/websocket";
  xmlhttp.open("POST",url, true);
  xmlhttp.setRequestHeader("Content-Type", "application/json");
  xmlhttp.setRequestHeader("Authorization", "xelion " + authentication);
  xmlhttp.send();
}

function openWebSocket()
{
  var wsurl = document.getElementById("ws").value;
  initWebSocket(wsurl);
}


function setMainUrl()
{
  var host = document.getElementById("host").value;
  var tenant = document.getElementById("tenant").value;
  var port = document.getElementById("port").value;
  var ssl = document.getElementById("ssl").checked;

  if(ssl)
  {
    mainUrl = "https://";
  }
  else
  {
    mainUrl = "http://";
  }
  mainUrl = mainUrl + host;
  if(port.length != 0)
  {
    mainUrl = mainUrl + ":" + port;
  }
  mainUrl = mainUrl + "/api/v1/" + tenant;
}
